package koeln.uni.idh.java1.session11.zoo.ui;

import koeln.uni.idh.java1.session11.zoo.IsDrawable;

public class AsciiImage {

	/**
	 * The width of an image
	 */
	int width;

	/**
	 * The image itself, as ASCII-art
	 */
	char[][] image;

	/**
	 * Creates a new empty image with the given width, which is expressed as the
	 * number of columns in each line.
	 * 
	 * @param width An integer value that represents the width of the image
	 */
	public AsciiImage(int width, int height) {
		this.width = width;

		// Initially, the image is empty
		this.image = new char[height][width];
		for (int h = 0; h < image.length; h++) {
			for (int w = 0; w < image[0].length; w++) {
				image[h][w] = '.';
			}
		}
	}

	public void dot(int x, int y) {
		image[y][x] = '#';
	}
	
	public void dot(int x, int y, char ch) {
		image[y][x] = ch;
	}

	public void dot(int x, int y, IsDrawable id) {
		image[y][x] = id.getSymbol();
	}
	
	public String toString() {
		String r = "";
		for (int h = 0; h < image.length; h++) {
			for (int w = 0; w < image[h].length; w++) {
				r += image[h][w];
			}
			r += "\n";
		}
		return r;
	}


}
